#include <bits/stdc++.h>

const int MAXN = 1e5;

std::vector<int> readAndParse() {
	std::string s;
	std::cin >> s;
	s += '.';
	std::string current;
	std::vector<int> answer;
	for (int i = 0; i < (int)s.size(); i++) {
		if (s[i] == '.') {
			answer.push_back(std::stoi(current));
			current = "";
		} else {
			current += s[i];
		}
	}
	return answer;
}

unsigned long long encode(const std::vector<int> &a) {
	unsigned long long result = 0;
	for (int i = 0; i < (int)a.size(); i++) {
		result = result * 256 + a[i];
	}
	return result;
}

int main() {
	int n, x;
	std::cin >> n >> x;
	std::unordered_set<unsigned long long> as;
	for (int i = 0; i < n; i++) {
		as.insert(encode(readAndParse()));
	}
	unsigned long long ea = encode(readAndParse());
	unsigned long long eb = encode(readAndParse());
	int between = 0;
	for (auto value : as) if (ea <= value && value <= eb) between++;
	unsigned long long current = ea;
	while (current < eb) {
		if (!as.count(current) && !as.count(current + 1)) {
			std::cout << eb - ea - between - 1 << '\n';
			return 0;
		}
		current++;
	}
	std::cout << "-1\n";
	return 0;
}